#!/usr/bin/php-cgi
<?php
function random_choice($array)
{
  return $array[array_rand($array)];
}
function createSchedule($nr_of_teams)
{
  if ($nr_of_teams%2 == 1)
  {
    $odd_team_nr = true;
  }
  else
  {
    $odd_team_nr = false;
  };
  if ($odd_team_nr == true)
  {
    $nr_of_teams++;
  };
  if ($nr_of_teams == 2)
  {
    return array(array(array(0,1)),array(array(1,0)));
  }
  elseif ($nr_of_teams == 4)
  {
    return array(
            array(array(0,1), array(2,3)),
            array(array(2,0), array(3,1)),
            array(array(0,3), array(1,2)),
            array(array(1,0), array(3,2)),
            array(array(0,2), array(1,3)),
            array(array(3,0), array(2,1)));
  };

  $teamdict = array();
  $lastlist = array();
  $nr_of_teams--;
  for ($team = 0;  $team <= $nr_of_teams - 1; $team++)
  {
    $startpoint = $nr_of_teams - $team - 1;
    $start = range($startpoint+1,$nr_of_teams - 1);
    $end = range(0,$startpoint);
    if ($startpoint > $nr_of_teams-2)
    {
      $start = array();
    };
    if ($startpoint < 1)
    {
      $end = array();
    };
    if(in_array($team, $start))
    {
      $index = array_search($team, $start);
      $lastlist[$index] = $team;
      $start[$index] = $nr_of_teams;
    }
    elseif (in_array($team, $end))
    {
      $index = array_search($team, $end);
      $lastlist[count($start) + $index] = $team;
      $end[$index] = $nr_of_teams;
    }
    $teamdict[$team] = array_merge($start, $end);
  };
  $teamdict[$nr_of_teams] = $lastlist;
  //ksort($teamdict[$nr_of_teams]); print_r($teamdict);

  if (key_exists(NULL, $teamdict))
  {
    unset($teamdict[NULL]);
  };
  $schedule = array();
  $schedule_ = array();
  $day = 0;
  for ($week = 0; $week < $nr_of_teams; $week++)
  {
    $matches = array();
    $matches_ = array();
    $today_playing = array();
    for ($team = 0;  $team <= $nr_of_teams; $team++)
    {
      if (in_array($team, $today_playing) == false)
      {
        if ($day%2 == 0)
        {
          $matches[] = array($team,$teamdict[$team][$week]);
          $matches_[] = array($teamdict[$team][$week],$team);
        }
        else
        {
          $matches[] = array($teamdict[$team][$week],$team);
          $matches_[] = array($team,$teamdict[$team][$week]);
        };
        $today_playing[] = $team;
        $today_playing[] = $teamdict[$team][$week];
      };
    };
    $schedule[] = $matches;
    $schedule_[] = $matches_;
    $day++;
  };
  return array_merge($schedule,$schedule_);
};

class team
{
  protected $name;
  protected $defense;
  protected $offensive;
  protected $matches; //gehört eigentlich in die Liga, nicht ins Team!
  function __construct($name)
  {
    $this->matches = array();
    $this->name = $name;
    $this->defense = rand(1,4);
    $this->offensive = rand(3,7);
  }

  public function getName()
  {
    return $this->name;
  }
  
  public function getPoints($day)
  {
    $day++;
    $points = 0;
    $matches = array_slice($this->matches, 0, $day);
    foreach ($matches as $match)
    {
      if ($match !== NULL)
      {
        if ($match[0] == $match[1])
        {
            $points++;
        }
        elseif ($match[0] > $match[1])
        {
          $points = $points + 3;
        };
      };
    };
    return $points;
  }
  
  public function getMatches($day)
  {
    $day++;
    $matches = array_slice($this->matches, 0, $day);
    return count($matches) - count(array_keys($matches,NULL));
  }

  public function getGoalDifference($day)
  {
    $day++;
    $matches = array_slice($this->matches, 0, $day);
    $goal_difference = 0;
    foreach ($matches as $match)
    {
      if ($match !== NULL)
      {
        $goal_difference = $goal_difference + $match[0] - $match[1];
      };
    };
    return $goal_difference;
  }

  public function addMatch($data)
  {
    $this->matches[] = $data;
  }

  public function getDefense()
  {
    return round($this->defense,0) + rand(-7,6);
  }

  public function getOffensive()
  {
    return round($this->offensive,0) + rand(-7,8);
  }

  public function getTeamPower()
  {
    return $this->defense + $this->offensive + rand(-1,1);
  }

  public function lost()
  {
    $rand = random_choice(array("d","d","d","o","o","","","","","","","","","","",""));
    if ($rand == "d")
    {
      $this->defense = $this->defense - 0.5;
    }
    elseif ($rand == "o")
    {
      $this->offensive = $this->offensive - 0.3;
    };
  }

  public function won()
  {
    $rand = random_choice(array("d","d","o","o","o","","","","","","","",""));
    if ($rand == "d")
    {
      $this->defense = $this->defense + 1;
    }
    elseif ($rand == "o")
    {
      $this->offensive = $this->offensive + 1.4;
    }
  }
  public function outsiderWon()
  {
    $rand_array = array(0,0,0,1,2,3,1.6,2,2.2,2.4);
    $this->defense = $this->defense + random_choice(array_merge(array(0),$rand_array));
    $this->offensive = $this->offensive + random_choice($rand_array);
  }
};

function sort_teams($team1, $team2, $day)
{
  if($team1 instanceof team and $team2 instanceof team)
  {
    if ($team1->getPoints($day) > $team2->getPoints($day))
    {
      return -1;
    }
    elseif ($team1->getPoints($day) == $team2->getPoints($day))
    {
      if ($team1->getGoalDifference($day) > $team2->getGoalDifference($day))
      {
        return -1;
      }
      else
      {
        return 1;
      };
    }
    else
    {
      return 1;
    };
  }
  else
  {
    return 1;
  };
};

class no_game extends team
{
  function __construct($name="")
  {
    $this->matches = array();
    $this->name = "spielfrei";
    $this->defense = 0;
    $this->offensive = 0;
  }
  public function getPoints($day){return "-";}
  public function getMatches($day){return "-";}
  public function getGoalDifference($day){return "-";}
  public function addMatch($data){}
  public function lost(){}
  public function won(){}
  public function outsiderWon(){}
};

class league
{
  protected $teamlist;
  protected $schedule;
  protected $matchlist;
  protected $results;
  protected $odd_team_nr;
  protected $list_of_names;
  protected $filename_of_savedata;
  protected $filename_of_formatfile;
  protected $last_generated_day;
  protected $daylist;
  protected $password;
  protected $salt;

  function __construct($list_of_names, $filename_of_savedata = "soccer_league.save", $filename_of_formatfile="soccer_template.html", $password = "", $salt="64027e107088as66d2fj488f505l8af8ac97q")
  {
    $this->last_generated_day = 0;
    $this->list_of_names = $list_of_names;
    $this->filename_of_savedata = $filename_of_savedata;
    $this->filename_of_formatfile = $filename_of_formatfile;
    $this->daylist = array();
    if (count($this->list_of_names)%2 == 1)
    {
      $this->odd_team_nr = true;
    }
    else
    {
      $this->odd_team_nr = false;
    };
    $this->password = $password;
    $this->salt = $salt;
    $this->results = array();
    $this->schedule = createSchedule(count($this->list_of_names));
    $this->createTeamlist();
    $this->createMatchlist();
  }
  
  private function createTeamlist()
  {
    $text = array();
    $teamlist = array();
    foreach ($this->list_of_names as $name)
    {
      if ($name !== NULL)
      {
        $teamlist[] = new team($name);
      }
      else
      {
        $teamlist[] = new no_game();
      };
    };
    if ($this->odd_team_nr == true)
    {
      $teamlist[] = new no_game();
    };
    $this->teamlist = $teamlist;
  }
  
  private function createMatchlist()
  {
    $matchlist = array();
    foreach($this->schedule as $week)
    {
      $matchlist_week = array();
      foreach($week as $match)
      {
        $teams = array();
        foreach($match as $team)
          {
            $teams[] = $this->teamlist[$team];
          };
        $matchlist_week[] = $teams;
      };
      $matchlist[] = $matchlist_week;
    };
    $this->matchlist = $matchlist;
  }

  private function play($team1,$team2)
  {
    if ((($team1 instanceof no_game) == false) and (($team2 instanceof no_game) == false))
    {
      $team1_goalpoints = $team1 -> getOffensive() - $team2 -> getDefense() + 1;
      $team2_goalpoints = $team2 -> getOffensive() - $team1 -> getDefense();
      if ($team1_goalpoints < 0)
      {
        $team1_goalpoints = 0;
      };
      if ($team2_goalpoints < 0)
      {
        $team2_goalpoints = 0;
      };
      $team1_goals = ($team1_goalpoints - ($team1_goalpoints%5))/5;
      $team2_goals = ($team2_goalpoints - ($team2_goalpoints%5))/5;
      if ($team1_goals > 5)
      {
        $team1_goals = random_choice(array(4,5,5,6));
      };
      if ($team2_goals > 5)
      {
        $team2_goals = random_choice(array(4,5,5,6));
      };

      $team1->addMatch(array($team1_goals,$team2_goals));
      $team2->addMatch(array($team2_goals,$team1_goals));

      if($team1_goals > $team2_goals)
      {
        $team1->won();
        $team2->lost();
      }
      elseif($team2_goals > $team1_goals)
      {
        $team2->won();
        $team1->lost();
      };
      
      $teampower_diff = $team1->getTeamPower()-$team2->getTeamPower();
      if(($teampower_diff < -12) and $team1_goals+rand(0,2) >= $team2_goals+rand(0,(-$teampower_diff/8)))
      {
        $team1->outsiderWon();
      }
      elseif(($teampower_diff > 12) and $team2_goals+rand(0,2) >= $team1_goals+rand(0,($teampower_diff/8)))
      {
        $team2->outsiderWon();
      }
      return array(array($team1, $team1_goals), array($team2, $team2_goals));
    }
    else
    {
      $team1->addMatch(NULL);
      $team2->addMatch(NULL);
      return NULL;
    };
  }

  private function createAllMatches($matchlist_of_day)
  {
    $day = array();
    foreach($matchlist_of_day as $match)
    {
      $teams = array();
      foreach($match as $team)
        {
          $teams[] = $team;
        };
      $result = $this->play($teams[0],$teams[1]);
      if ($result === NULL)
      {
        $day[] = array(
            array($teams[0],NULL),
            array($teams[1],NULL));
      }
      else
      {
        $day[] = $result;
      };
    };
    return $day;
  }

  private function createMatchesOfDay($day)
  {
    $new = false;
    for ($cur_day = 0; $cur_day <= $day; $cur_day++)
    {
      if(key_exists($cur_day, $this->results) == false)
      {
        $matchlist_of_day = $this->matchlist[$cur_day];
        $this->results[$cur_day] = $this->createAllMatches($matchlist_of_day);
        if ($new == false)
        {
          $new == true;
        };
      };
      if ($new = true)
      {
        $this->writeData();
      };
    };
  }

  private function getTable($day)
  {
    $teamlist = $this->teamlist;
    usort($teamlist, create_function("\$team1, \$team2","return sort_teams(\$team1, \$team2,  $day );"));
    return $teamlist;
  }

  public function createDaylist($days_until_start, $days_between, $time="00:00:01")
  {
    $this->daylist = array();
    $nr_of_teams = count($this->teamlist);
    if ($this->odd_team_nr == false)
    {
      $nr_of_teams--;
    };
    $first_day = new DateTime();
    $time = split(":", $time);
    $first_day->setDate((int)$first_day->format("Y"), (int)$first_day->format("m"), (int)$first_day->format("d")+$days_until_start);
    $first_day->setTime($time[0],$time[1],$time[2]);
    $this->daylist[] = $first_day;
    for ($day = 0; $day+1 < $nr_of_teams*2; $day++)
    {
      $last_day = $this->daylist[$day];
      $day_obj = new DateTime();
      $day_obj->setDate((int)$last_day->format("Y"), (int)$last_day->format("m"), (int)$last_day->format("d"));
      $day_obj->setTime($time[0],$time[1],$time[2]);
      $day_obj->add(new DateInterval("P" . $days_between . "D"));
      $this->daylist[] = $day_obj;
    };
    $this->writeData();
  }

  public function changeFilenameOfSavegame($filename_of_savedata)
  {
    $this->filename_of_savedata = $filename_of_savedata;
  }
  public function changeFilenameOfFormatfile($filename_of_formatfile)
  {
    $this->filename_of_formatfile = $filename_of_formatfile;
  }
  
  public function writeData()
  {
    $savedata = serialize(array($this->list_of_names,$this->teamlist,$this->results,$this->daylist,$this->filename_of_formatfile,$this->password,$this->salt));
    file_put_contents($this->filename_of_savedata,$savedata);
  }

  public function loadData()
  {
    $text = file_get_contents($this->filename_of_savedata);
    $savedata = unserialize($text);
    $this->list_of_names = $savedata[0];
    if (count($this->list_of_names)%2 == 1)
    {
      $this->odd_team_nr = true;
    }
    else
    {
      $this->odd_team_nr = false;
    };
    $this->schedule = createSchedule(count($this->list_of_names));
    $this->teamlist = $savedata[1];
    $this->createMatchlist();
    $this->results = $savedata[2];
    $this->daylist = $savedata[3];
    $this->filename_of_formatfile = $savedata[4];
    $this->password = $savedata[5];
    $this->salt = $savedata[6];
  }

  protected function getDay($day=-1,$schedule_only=false)
  {
    if ($day == -1)
    {
      $day = $this->last_generated_day;
    }
    else
    {
      $day--;
    };
    if (key_exists($day,$this->schedule) == false)
    {
      $day = max(array_keys($this->schedule));
    };
    $this->last_generated_day = $day+1;
    $text = array($day+1);
    $matchlist_of_day = $this->matchlist[$day];
    $matchtable = array();
    if ($schedule_only == false)
    {
      $this->createMatchesOfDay($day);
      $results = $this->results[$day];
    }
    else
    {
      $results = array();
      foreach ($this->matchlist[$day] as $match)
      {
        $results[] = array(array($match[0],""),array($match[1],""));
      };
    };

    foreach ($results as $match)
    {
      if ($match[0][1] === NULL)
      {
        $matchtable[] = array(
            array($match[0][0]->getName(),""),
            array($match[1][0]->getName(),""));
      }
      else
      {
        $matchtable[] = array(
            array($match[0][0]->getName(),$match[0][1]),
            array($match[1][0]->getName(),$match[1][1]));
      };
    };
    $text[] = $matchtable;
    if ($schedule_only == false)
    {
      $teamtable = array();
      foreach ($this->getTable($day) as $team)
      {
        if (($team instanceof no_game) == false)
        {
          $teamtable[] = array($team->getName(),$team->getPoints($day),$team->getGoalDifference($day),$team->getMatches($day));
        };
      };
    }
    else
    {
      foreach($this->list_of_names as $name)
      {
        $teamtable[] = array($name,"","","");
      }
    };
    $text[] = $teamtable;
    return $text;
  }

  public function getDaylistDay($day)
  {
    if ($this->daylist == array())
    {
      return array_merge(array(NULL),$this->getDay($day),array(false));
    }
    else
    {
      $check_day = $this->daylist[$day-1];
      $now = new DateTime();
      if ((int)$now->format("Ymd") >= (int)$check_day->format("Ymd"))
      {
        return array_merge(array($check_day->format("d.m.Y")),$this->getDay($day),array(false));
      }
      else
      {
        return array_merge(array($check_day->format("d.m.Y")),$this->getDay($day,true),array(true));
      };
    };
  }

  protected function restartFromFormula($new_password=false)
  {
    $this->results = array();
    $nr_of_teams = $_POST["nr_of_teams"];
    if ($nr_of_teams%2 == 1)
    {
      $this->odd_team_nr = true;
      $this->schedule = createSchedule($nr_of_teams+1);
    }
    else
    {
      $this->odd_team_nr = false;
      $this->schedule = createSchedule($nr_of_teams);
    };
    if ($new_password == true)
    {
      $this->password = crypt($_POST["password"],$this->salt);
    };
    $prefixes = split(" ",htmlentities($_POST["prefixes"],2, 'utf-8'));
    $prefixes[] = "";
    foreach (array("prefix_FC", "prefix_VfL", "prefix_SC", "prefix_SSV", "prefix_SV", "prefix_BSG", "prefix_SuS", "prefix_TSV", "prefix_SpVgg", "prefix_TSG", "prefix_USV", "prefix_SG", "prefix_1. FC", "prefix_FK",  "prefix_TuS") as $prefix)
    {
      if (isset($_POST[$prefix]) and $_POST[$prefix] == "true")
      {
        $splittext = split("_",$prefix);
        $prefixes[] = $splittext[1];
      };
    };
    if (count($prefixes) == 1)
    {
      $prefixes[] = "FC";
    };
    $names = split("\n",htmlentities($_POST["names"]),2, 'utf-8');
    $names[] = "";
    foreach (array("name_Union", "name_Dynamo", "name_Libertas", "name_Victoria", "name_Olympia", "name_Concordia", "name_Constantia", "name_Athletik", "name_Kickers", "name_Vorwärts", "name_Blau-Weiß", "name_Blau-Gold",  "name_Rot-Weiß", "name_Rot-Gold", "name_Grün-Weiß", "name_Grün-Gold") as $name)
    {
      if (isset($_POST[$name]) and $_POST[$name] == "true")
      {
        $splittext = split("_",$name);
        $names[] = $splittext[1];
      };
    };
    $places = array();
    $teams = array();
    for ($i = 1; $i<21; $i++)
    {
      if (array_key_exists("place" . $i . "_name",$_POST) and str_replace(" ","",$_POST["place" . $i . "_name"]) != "")
      {
        for ($i_ = 0; $i_ <= (int)$_POST["place" . $i . "_size"]; $i_ ++)
        {
          $places[] = htmlentities($_POST["place" . $i . "_name"],2, 'utf-8');
        };
      };
      if (array_key_exists("team" . $i, $_POST) and str_replace(" ","",$_POST["team" . $i]) != "")
      {
        $teams[] = htmlentities($_POST["team" . $i],2, 'utf-8');
      };
    };
    if (count($teams) < $nr_of_teams)
    {
      $teams = array_slice($teams,0,$nr_of_teams);
    };
    while (count($teams) < $nr_of_teams)
    {
      $prefix = random_choice($prefixes);
      $name = random_choice($names);
      if ($prefix != "" and $name != "")
      {
        $teams[] =  $prefix . " " . $name . " " . random_choice($places);
      }
      elseif ($prefix != "" xor $name != "")
      {
        $teams[] =  $prefix . $name . " " . random_choice($places);
      }
      else
      {
        $teams[] =  random_choice($places) . " " . random_choice(array("0","8","9")) . rand(0,9);
      }
    };
    $this->list_of_names = $teams;
    $this->createTeamlist();
    $this->createMatchlist();
    $this->createDaylist((int)$_POST["days_until_start"], (int)$_POST["days_between"]);
    $this->writeData();
    return $this->printDay();
  }

  protected function checkNrOfPlaces($new_password = false)
  {
    $nr = 0;
    for ($i = 1; $i<21; $i++)
    {
      if (array_key_exists("place" . $i . "_name",$_POST) and str_replace(" ","",$_POST["place" . $i . "_name"]) != "")
      {
        $nr++;
      }
    }
    if ($nr < 2)
    {
      return "BITTE GEBEN SIE MINDESTENS ZWEI ORTE IN DEN ENTSPRECHENDEN FELDERN EIN!";
    }
    elseif ($new_password == true and (array_key_exists("password",$_POST) == false or str_replace(" ","",$_POST["password"]) == ""))
    {
      return "BITTE GEBEN SIE EIN PASSWORT EIN!";
    }
    else
    {
      return NULL;
    }
  }

  protected function printFormula($error=NULL, $new_password=false)
  {
    $formulatext = array('      <form style="text-align:left;" method="POST" action="' . basename($_SERVER["SCRIPT_FILENAME"]) . '">
        <fieldset>
            <legend><h1>Neue Liga generieren</h1></legend>');
    if ($new_password == true)
    {
      $formulatext[] ='             <fieldset>
                <legend>Passwort</legend><p>Bitte geben sie ein Admin-Passwort ein.<br />
                Sie benötigen dieses Password, um später die Daten der Liga verändern zu können.<br />
                ACHTUNG: Sie können dieses Passwort später nicht mehr ändern!!!</p>
                <input name="password" type="password" size="15" maxlength="15"></fieldset>';
    };
    $formulatext[] = '            <fieldset>
                <legend>Allgemeines</legend>
                Mannschaftszahl <select name="nr_of_teams" size="1">';
    for ($i = 2; $i<21; $i++)
    {
      if (($new_password == true and ($error === NULL or $i != (int)$_POST["nr_of_teams"])) or ($new_password == false and $i != count($this->list_of_names)))
      {
        $formulatext[] = '                  <option>' . $i . '</option>';
      }
      else
      {
        $formulatext[] = '                  <option selected="selected">' . $i . '</option>' ;       
      };
    };
    $formulatext[] = '                </select> &nbsp;Ligastart in <select name="days_until_start" size="1">';
    for ($i = 0; $i<31; $i++)
    {
      if ($error === NULL or $i != (int)$_POST["days_until_start"])
      {
        $formulatext[] = '                  <option>' . $i . '</option>';
      }
      else
      {
        $formulatext[] = '                  <option selected="selected">' . $i . '</option>' ;       
      };
    };
    $formulatext[] = '                </select>Tagen &nbsp;Neuer Spieltag alle <select name="days_between" size="1">';
    if ($new_password == false)
    {
       $first_day = $this->daylist[0];
       $first_day = $first_day->format("Ymd");
       $second_day = $this->daylist[1];
       $second_day = $second_day->format("Ymd");
       $days_between = (int)$second_day - (int)$first_day;
    }
    for ($i = 0; $i<31; $i++)
    {
      if (($new_password == true and ($error === NULL or $i != (int)$_POST["days_between"])) or ($new_password == false and $i != $days_between))
      {
        $formulatext[] = '                  <option>' . $i . '</option>';
      }
      else
      {
        $formulatext[] = '                  <option selected="selected">' . $i . '</option>' ;       
      };
    };
    $formulatext[] = '                </select>Tage            </fieldset>
            <fieldset style="float: left; width:30%">
                <legend>Mannschafts-Präfixe</legend>
                <p>Bitte wählen Sie die gewünschten Präfixe aus!</p>';
    foreach (array(array("FC","VfL","SC"),array("SSV","SV","BSG"),array("SuS","TSV","SpVgg"), array("TSG","USV","SG"), array("1. FC","FK", "TuS")) as $prefix_rows)
    {
      foreach ($prefix_rows as $prefix_cols)
      {
        if ($error === NULL or array_key_exists("prefix_" . $prefix_cols,$_POST) == false)
        {
          $formulatext[] = '                <input type="checkbox" name="prefix_' . $prefix_cols . '" value="true" />' . $prefix_cols . '&nbsp;';
        }
        else
        {
          $formulatext[] = '                <input type="checkbox" name="prefix_' . $prefix_cols . '" value="true" checked="checked" />' . $prefix_cols . '&nbsp;';
        };
      };
      $formulatext[] = '<br />';
    };
    $formulatext[] = '                <p>Sie können auch eigene Präfixe definieren<br />
                (Durch Leerzeichen getrennt)</p>';
    if ($error === NULL or array_key_exists("names",$_POST) == false)
    {
      $formulatext[] = '                <input type="text"  name="prefixes" size="20" maxlength="50">';
    }
    else
    {
      $formulatext[] = '                <input type="text"  name="prefixes" size="20" maxlength="50" value="' .htmlentities($_POST["names"],2, 'utf-8'). '"></textarea>';
    };
    $formulatext[] = '            </fieldset>
            <fieldset style="width:60%; float:left;">
                <legend>Mannschaftsbezeichner</legend>
                <p>Bitte wählen Sie die gewünschten Bezeichner aus!</p>';
    foreach (array(array("Union","Dynamo","Libertas","Victoria"),array("Olympia","Concordia","Constantia","Athletik"),array("Kickers","Vorwärts","Blau-Weiß","Blau-Gold"), array("Rot-Weiß","Rot-Gold","Grün-Weiß","Grün-Gold")) as $name_rows)
    {
      foreach ($name_rows as $name_cols)
      {
        if ($error === NULL or array_key_exists("name_" . $name_cols, $_POST) == false)
        {
          $formulatext[] = '                <input type="checkbox" name="name_' . $name_cols . '" value="true" />' . $name_cols . '&nbsp;';
        }
        else
        {
          $formulatext[] = '                <input type="checkbox" name="name_' . $name_cols . '" value="true" checked="checked"/>' . $name_cols . '&nbsp;';
        }
      };
      $formulatext[] = '<br />';
    };
    $formulatext[] = '                <p>Sie können auch eigene Bezeichner definieren<br />
                (Durch Zeilenumbruch getrennt)</p>';
    if ($error === NULL or array_key_exists("names",$_POST) == false)
    {
      $formulatext[] = '                <textarea name="names" cols="40" rows="5"></textarea>';
    }
    else
    {
      $formulatext[] = '                <textarea name="names" cols="40" rows="5" value="' .htmlentities($_POST["names"],2, 'utf-8'). '"></textarea>';
    };
    $formulatext[] = '            </fieldset>
            <fieldset style="float:left; width:75%; font-size:80%">
                <legend>Orte</legend>
                <p>Bitte geben Sie (mind. 2) Orte ihres Landes und deren Größe ein!</p>
                <div style="float:left; text-align:center;padding:5px">';
    for ($i = 1; $i < 11; $i++)
    {
      if ($new_password == true and ($error === NULL or array_key_exists("place" . $i . "_name",$_POST) == false))
      {
        $formulatext[] = '                    <input type="text"  name="place' . $i . '_name" size="25" maxlength="50"><br />';
      }
      elseif ($new_password == false and $i < 3)
      {
        $formulatext[] = '                    <input type="text"  name="place' . $i . '_name" size="25" maxlength="50" value="Testort"><br />';
      }
      else
      {
        $formulatext[] = '                    <input type="text"  name="place' . $i . '_name" size="25" maxlength="50" value="' . htmlentities($_POST["place" . $i . "_name"],2, 'utf-8') . '"><br />';
      }      
      $formulatext[] = '                    klein';
      for ($i_ = 0; $i_ < 7; $i_++)
      {
        if (($error !== NULL and $i_ != (int)$_POST["place" . $i . "_size"]) or ($error === NULL and $i_ != 3))
        {
          $formulatext[] = '                    <input type="radio" name="place' . $i . '_size" value="' . $i_ . '">';
        }
        else
        {
          $formulatext[] = '                    <input type="radio" name="place' . $i . '_size" value="' . $i_ . '" checked="checked">';
        };
      };
      $formulatext[] = '                    groß<br /><br />';
    };
    $formulatext[] = '                </div>
                <div style="text-align:center;padding:5px">';
    for ($i = 11; $i < 21; $i++)
    {
      if ($error === NULL or array_key_exists("place" . $i . "_name",$_POST) == false)
      {
        $formulatext[] = '                    <input type="text"  name="place' . $i . '_name" size="25" maxlength="50"><br />';
      }
      else
      {
        $formulatext[] = '                    <input type="text"  name="place' . $i . '_name" size="25" maxlength="50" value="' . htmlentities($_POST["place" . $i . "_name"],2, 'utf-8') . '"><br />';
      }      
      $formulatext[] = '                    klein';
      for ($i_ = 0; $i_ < 7; $i_++)
      {
        if (($error !== NULL and $i_ != (int)$_POST["place" . $i . "_size"]) or ($error === NULL and $i_ != 3))
        {
          $formulatext[] = '                    <input type="radio" name="place' . $i . '_size" value="' . $i_ . '">';
        }
        else
        {
          $formulatext[] = '                    <input type="radio" name="place' . $i . '_size" value="' . $i_ . '" checked="checked">';
        };
      };
      $formulatext[] = '                    groß<br /><br />';
    };
    $formulatext[] = '                </div>
                <!--HTML5-Alternative:
                Name:<input type="text"  name="place1_name" size="15" maxlength="50">
                sehr klein<input type="range" name="place1_size" min="0", max="6",steps="1", value="3" >sehr groß<br />
                -->
            </fieldset>
            <fieldset style="float:left; width:8%">
                <legend>Mannschaften</legend>
                <p>Sie können auch bereits bestehende Mannschaften eingeben</p>';
    for ($i = 1; $i < 21; $i++)
    {
        if ($new_password == true and ($error === NULL or array_key_exists("team" . $i ,$_POST) == false))
        {
          $formulatext[] = '                <input type="text"  name="team' . $i . '" size="15" maxlength="50"><br />';
        }
        elseif ($new_password == false)
        {
          $formulatext[] = '                <input type="text"  name="team' . $i . '" size="15" maxlength="50" value="' . htmlentities($this->list_of_names[$i-1]) . '"><br />';
        }
        else
        {
          $formulatext[] = '                <input type="text"  name="team' . $i . '" size="15" maxlength="50" value="' . htmlentities($_POST["team" . $i],2, 'utf-8') . '"><br />';
        }
    };
    $formulatext[] = '            </fieldset>
        <input type="submit" value=" Absenden ">
        <input type="hidden" name="submit" value="true">';
    if ($new_password == false)
    {
      $formulatext[] = '        <input type="hidden" name="admin_submit" value="true">';
      $formulatext[] = '        <input type="hidden" name="password" value="' . htmlentities($_POST['password'],2, 'utf-8') . '">';
    };
    $formulatext[] = '        </fieldset>
      </form>';
    $htmltext = file_get_contents($this->filename_of_formatfile);
    $endtext = str_replace("<!--Haupt-Text-->", join("\n",$formulatext),$htmltext );
    return str_replace("<!--Hinweis-Text-->",$error, $endtext);
  }

  protected function printDay($error = NULL)
  {
    if (array_key_exists("day",$_GET) == false or (int)$_GET["day"] == 0)
    {
      $day = 1;
    }
    else
    {
      $day = (int)$_GET["day"];
    };
    $day_data = $this->getDaylistDay($day);
    $daytext = array();
    $daytext[] = '      <h1>' . $day_data[1] . '. Spieltag (' . $day_data[0] . ')</h1>
      <table width=100% border="1" rules="rows">
          <caption><h2>Spielergebnisse</h2></caption>
          <thead>
            <tr><th>Heim</th><th>Tore</th><th>Gast</th><th>Tore</th></tr>
          </thead>
          <tfood>';
    foreach ($day_data[2] as $match)
    {
        $daytext[] = '            <tr><td>' . $match[0][0] . '</td><td>' . $match[0][1] . '</td><td>' . $match[1][0] . '</td><td>' . $match[1][1] . '</td></tr>';
    };
    $daytext[] = '          </tfood>
      </table>
      <br />
      <table width=100%  border="1" rules="rows">
          <caption><h2>Tabelle</h2></caption>
          <thead>
            <tr><th>Mannschaft</th><th>Punkte</th><th>Torverhältnis</th><th>Spiele</th></tr>
          </thead>
          <tfood>';
    foreach ($day_data[3] as $team)
    {
      $daytext[] = '<tr><td>' . $team[0] . '</td><td>' . $team[1] . '</td><td>' . $team[2] . '</td><td>' . $team[3] . '</td></tr>';
    };
    $daytext[] = '            </tfood>
      </table>';
    $daytext[] = '      <form style="text-align:left;" method="POST" action="' . basename($_SERVER["SCRIPT_FILENAME"]) . '">
      <p style="font-size:60%;">Zum Admin-Bereich:<br />Passwort:<input name="password" type="password" size="12" maxlength="12"><input type="hidden" name="admin_submit" value="true"><input type="submit" value=" Ok "></p></form>';
    $htmltext = file_get_contents($this->filename_of_formatfile);
    $endtext = str_replace("<!--Haupt-Text-->", join("\n",$daytext),$htmltext );
    $menutext = array('<form style="text-align:center;" method="GET" action="' . basename($_SERVER["SCRIPT_FILENAME"]) . '">');
    for ($i = 1; $i <= count($this->schedule); $i++)
    {
      $menutext[] = '<button type="submit" name="day" value="' . $i . '">' . $i . '</button>';
    }
    $menutext[] = '</form>';
    $endtext = str_replace("<!--Auswahl-Text-->", join("",$menutext),$endtext );
    if ($error != NULL)
    {
      $endtext = str_replace("<!--Hinweis-Text-->", $error . "<br /><!--Hinweis-Text-->", $endtext);
    };
    if ($day_data[4] == false)
    {
      return $endtext;
    }
    else
    {
      return str_replace("<!--Hinweis-Text-->", "Achtung! Der angezeigte Spieltag liegt in der Zukunft!", $endtext);
    };
  }
  
  public function printTextDay($day)
  {
    $day_data = $this->getDaylistDay($day);
    $daytext = array();
    $daytext[] = $day_data[1] . ". Spieltag (" . $day_data[0] . ")\n*************************\n\nSpiele\n======\n";
    foreach ($day_data[2] as $match)
    {
      $daytext[] = $match[0][0] . ": " . $match[0][1] . " - " . $match[1][0] . ": " . $match[1][1];
    };
    $daytext[] = "\nTabelle\n========\n";
    foreach ($day_data[3] as $team)
    {
      $daytext[] = $team[0] . ": " . $team[1] . " | " . $team[2] . " | " . $team[3];
    };
    $daytext[] = "";
    return join("\n",$daytext);
  }
  
  public function main()
  {
    if (count(array_keys(scandir(getcwd()),$this->filename_of_savedata)) == 0)
    {
      if (array_key_exists("submit",$_POST) == false)
      {
        return $this->printFormula("", true);
      }
      else
      {
        $error = $this->checkNrOfPlaces("", true);
        if ($error !== NULL)
        {
          return $this->printFormula($error,true);
        }
        else
        {
          return $this->restartFromFormula(true);
        };
      };
    }
    elseif (array_key_exists("admin_submit",$_POST) == true)
    {
      $this->loadData();
      if (crypt($_POST["password"],$this->salt) != $this->password)
      {
        return $this->printDay("Falsches Passwort!");  
      }
      elseif (array_key_exists("submit",$_POST) == false)
      {
        return $this->printFormula();
      }
      else
      {
        $error = $this->checkNrOfPlaces();
        if ($error !== NULL)
        {
          return $this->printFormula($error);
        }
        else
        {
          return $this->restartFromFormula();
        };
      };
    }
    else
    {
      $this->loadData();
      return $this->printDay();
    };
  }
};

$league = new league(array());
echo $league->main();
?>
